<?php

defined('_JEXEC') or die('Restricted access');
require_once dirname(__FILE__).'/../mabnalibs/mabnalibs.php';

class pm_mabna extends PaymentRoot
{
    function showPaymentForm($params, $pmconfigs)
    {
        require dirname(__FILE__) . "/paymentform.php";
    }

    //function call in admin
    function showAdminFormParams($params)
    {
        $array_params = array(
            'terminal_id',
            'transaction_end_status',
            'transaction_pending_status',
            'transaction_failed_status'
        );
        foreach ($array_params as $key) {
            if (!isset($params[$key])) $params[$key] = '';
        }

        $params['gate_type'] = isset($params['gate_type']) ? $params['gate_type'] : "0";
        $params['currency'] = isset($params['currency']) ? $params['currency'] : "0";
        $orders = JSFactory::getModel('orders', 'JshoppingModel'); //admin model
        require dirname(__FILE__) . "/adminparamsform.php";
    }

    function checkTransaction($pmconfigs, $order, $act)
    {
        $app = JFactory::getApplication();
        $input = $app->input;
		
		$MerchantID = $pmconfigs['terminal_id'];
		$session =& JFactory::getSession();
		$Amount = (int)$session->get('amount');
		$Authority = $input->getString('Authority');

		
		if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
		{
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			 $query->select(array('COUNT(*)'))->from($db->quoteName('#__jshopping_mabna'))
			 ->where($db->quoteName('ref_id') . ' LIKE '. $db->quote('%'.$_POST['digitalreceipt'].'%'));
			$db->setQuery($query);
			$results = $db->loadResult();
			if($results == 0)
			{
				 $payResult = mabnaClass::getMabna($_POST,$MerchantID); 
			}else
			{
				$payResult[0] = 0;
				$payResult[1] = 'رسید قبلا استفاده شده است';
			}
		}
		else
		{
			$payResult[0] = 0;
			$payResult[1] = $_POST['respmsg'];
		}
		
		
		if($payResult[0])
		{
			$RefID = $payResult[2];

			$transaction = new stdClass();
			$transaction->id = null;
			$transaction->order_id = (string)$order->order_id;
			$transaction->ref_id = (string)$RefID;
			$transaction->amount = (string)$Amount;

			JFactory::getDBO()->insertObject('#__jshopping_mabna', $transaction);

			$message = "خرید شما موفق بود <br> شماره سفارش شما: {$order->order_id} <br>شماره پیگیری مبنا کارت: {$RefID}";
			$app->enqueueMessage($message, 'message');
			return array(1, $message, $RefID);
		}else
		{
			$message = "خطای پیش آمده این است: " . '<br>' .$payResult[1] ;
			saveToLog("payment.log", "Status pending. Order ID " . $order->order_id . ". Error Reason: " . $payResult[2]);
			return array(0, $message);
		}
            
    }

    function showEndForm($pmconfigs, $order)
    {
        // mabna request context
        $MerchantID = '';
        $terminal_id = $pmconfigs['terminal_id'];
        $Amount = $this->mabnaAmount($order->order_total, $pmconfigs['currency']);
        $Description = "سفارش شماره " . $order->order_number;
        $Email = $order->email;
        $Mobile = $order->phone;
        $pm_method = $this->getPmMethod();
        $uri = JURI::getInstance();
        $liveurlhost = $uri->toString(array("scheme", 'host', 'port'));
        $return = $liveurlhost . SEFLink("index.php?option=com_jshopping&controller=checkout&task=step7&act=return&js_paymentclass=" . $pm_method->payment_class);
        $CallbackURL = $return . "&orderID=" . $order->order_id;

		$setPayment = mabnaClass::setMabna($Amount,$MerchantID,$terminal_id,$CallbackURL);
        echo $setPayment;
        exit;
        
    }

    function getUrlParams($pmconfigs)
    {
        $params = array();
        $params['order_id'] = JRequest::getInt("orderID");
        $params['hash'] = "";
        $params['checkHash'] = 0;
        $params['checkReturnParams'] = 1;
        return $params;
    }



    private function mabnaAmount($price, $currency)
    {
        if ($currency != 1)// $currency == '1' => 'rial'
        {
            $price *= 10;
        }

        return (int)$price;
    }
}